#!/bin/bash

# This file is executed when the docker container starts!

mkdir -p ./log/

if [ $# = 1 ] && [ $1 = "-test" ]; then
  echo "Running tests"
  # We always execute from src (For consistency with uWSGI)
  cd src
  uname -a
  export VIDEOAG_TEST_CONFIG_OVERRIDE="../config/test_config_override.py"
  python3 -V
  python3 -m coverage run --data-file "../coverage/.data" run_tests.py ||
    { echo "Test failed!"; exit 1; }
  python3 -m coverage report --data-file "../coverage/.data" --include "./*" ||
    { echo "Coverage report stdout failed"; exit 1; }
  python3 -m coverage report --data-file "../coverage/.data" -m --include "./*" > ../coverage/report.txt ||
    { echo "Coverage report report.txt failed"; exit 1; }
  python3 -m coverage html -d "../coverage/html/" --data-file "../coverage/.data" --include "./*" ||
    { echo "Coverage report html failed"; exit 1; }
else
  echo "Running uWSGI"
  uwsgi --ini ${VIDEOAG_UWSGI_CONFIG}
fi
