if __name__ == "__main__":
    print("You are running app.py as the main file. This is not supported and causes import errors. Execute with "
          "'flask run' instead or run 'run_dev.py' for debugging")
    exit(-1)

import os

from flask import Flask, Response


class ApiFlask(Flask):
    
    def make_default_options_response(self) -> Response:
        response = super().make_default_options_response()
        # max age is in seconds
        response.headers["Cache-Control"] = f"max-age={60 * 60}"
        return response


app = ApiFlask("api")

from videoag_common.miscellaneous.util import load_config_file, merge_config_into
import videoag_common
merge_config_into(app.config, videoag_common.config, overwrite_non_mergeable=True)  # TODO override required?

# A key is required for flask (This key is used to sign the cookies)
if "SECRET_KEY" not in app.config:
    app.config["SECRET_KEY"] = os.urandom(24)  # pragma: no cover

# Import routes AFTER initialization
# noinspection PyUnresolvedReferences
import api.routes
