import os
from pathlib import Path

if __name__ == '__main__':
    import json
    
    os.environ["API_SKIP_DRIFT_CHECK_WHEN_NO_CONNECTION"] = "true"
    
    # noinspection PyUnresolvedReferences
    import app  # Ensure everything is loaded
    from api.specification.generator import extract
    
    spec = extract()
    Path("../api_specification.json").write_text(json.dumps(spec.to_json(), indent="  ", sort_keys=True))
    template = Path("../api_specification_template.md").read_text()
    Path("../api_specification.md").write_text(spec.generate_markdown(template))
