from api_test import ApiTest

from videoag_common.test.object_data import *


class SiteTest(ApiTest):
    
    def test_status(self):
        # TODO test live config
        self.do_json_request(
            "GET",
            "/status",
            None,
            {
                "status": "available",
                "server_name": "dev",
                "announcements": [
                    TEST_DATA_ANNOUNCEMENT_1,
                    TEST_DATA_ANNOUNCEMENT_2,
                ]
            },
            ignore_array_order_keys=["announcements"],
            ignore_value_keys=["is_debug"]
        )
        self.do_json_request(
            "GET",
            "/status",
            None,
            {
                "status": "available",
                "server_name": "dev",
                "announcements": [
                    TEST_DATA_ANNOUNCEMENT_1_MOD,
                    TEST_DATA_ANNOUNCEMENT_2_MOD,
                    TEST_DATA_ANNOUNCEMENT_3_MOD,
                    TEST_DATA_ANNOUNCEMENT_4_MOD,
                    TEST_DATA_ANNOUNCEMENT_5_MOD
                ]
            },
            ignore_array_order_keys=["announcements"],
            ignore_value_keys=["is_debug"],
            use_moderator_login=True
        )
    
    def test_homepage(self):
        self.do_json_request(
            "GET",
            "/homepage",
            None,
            {
                "featured": [
                    TEST_DATA_FEATURED_3,
                    TEST_DATA_FEATURED_1,
                    TEST_DATA_FEATURED_4,
                ],
                "upcoming_lectures": [],
                "latest_lectures": [
                    TEST_DATA_LECTURE_25,
                ],
                "course_context": {
                    "2": TEST_DATA_COURSE_2_NO_LEC,
                    "3": TEST_DATA_COURSE_3_NO_LEC
                }
            },
            ["courses", "authentication_methods", "default_authentication_methods", "publish_media"]
        )
        self.do_json_request(
            "GET",
            "/homepage",
            None,
            {
                "featured": [
                    TEST_DATA_FEATURED_3_MOD,
                    TEST_DATA_FEATURED_2_MOD,
                    TEST_DATA_FEATURED_1_MOD,
                    TEST_DATA_FEATURED_4_MOD,
                ],
                "upcoming_lectures": [],
                "latest_lectures": [
                    TEST_DATA_LECTURE_1186_MOD,
                    TEST_DATA_LECTURE_186_MOD,
                    TEST_DATA_LECTURE_25_MOD,
                ],
                "course_context": {
                    "2": TEST_DATA_COURSE_2_NO_LEC_MOD,
                    "3": TEST_DATA_COURSE_3_NO_LEC_MOD,
                    "13": TEST_DATA_COURSE_13_NO_LEC_MOD,
                    "62": TEST_DATA_COURSE_62_NO_LEC_MOD,
                }
            },
            ["courses", "authentication_methods", "default_authentication_methods", "publish_media"],
            use_moderator_login=True
        )
